#ifndef LidarPerceptionSubDataWrapper_WRAPPER_HEADER_H
#define LidarPerceptionSubDataWrapper_WRAPPER_HEADER_H


#include "sub/SubDataWrapper.h"
#include "lidar_perception/executable.h"


template <typename DataType>
class LiDAR2LiDARPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};

template <typename DataType>
class HesaiRight_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};


template <typename DataType>
class HesaiLeft_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout << "Received type data from LiDAR is: " << sample->header.stampHigh << std::endl;
    }
};

template <typename DataType>
class SLAM2LiDARPerceptionOdom_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout<<"Received data from SLAM is: "<<sample->utc_timestamp<<std::endl;
    }
};

template <typename DataType>
class CAN2LiDARPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout<<"Received data from CAN is: "<<sample->VCU_Info_1_Signals.ses_en_sts<<std::endl;
    }
};

template <typename DataType>
class VED2LiDARPerception_SubDataWrapper : public SubDataWrapper<DataType>
{
void Process(ara::com::SamplePtr<DataType const>* ptr) override
    {
        auto sample = ptr->Get();
        std::cout<<"Received data from VED is: "<<sample->LongAcc<<std::endl;
    }
};

#endif
